Index: contrib/pf/net/if_pfsync.c
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/contrib/pf/net/if_pfsync.c,v
retrieving revision 1.35
diff -u -r1.35 if_pfsync.c
--- contrib/pf/net/if_pfsync.c	3 Jul 2007 12:16:07 -0000	1.35
+++ contrib/pf/net/if_pfsync.c	27 Jul 2007 13:34:19 -0000
@@ -282,12 +282,12 @@
 	ifp->if_hdrlen = PFSYNC_HDRLEN;
 	pfsync_setmtu(pfsyncif, ETHERMTU);
 #ifdef __FreeBSD__
-	callout_init(&pfsyncif->sc_tmo, NET_CALLOUT_MPSAFE);
+	callout_init(&pfsyncif->sc_tmo, CALLOUT_MPSAFE);
 #ifdef PFSYNC_TDB
-	callout_init(&pfsyncif->sc_tdb_tmo, NET_CALLOUT_MPSAFE);
+	callout_init(&pfsyncif->sc_tdb_tmo, CALLOUT_MPSAFE);
 #endif
-	callout_init(&pfsyncif->sc_bulk_tmo, NET_CALLOUT_MPSAFE);
-	callout_init(&pfsyncif->sc_bulkfail_tmo, NET_CALLOUT_MPSAFE);
+	callout_init(&pfsyncif->sc_bulk_tmo, CALLOUT_MPSAFE);
+	callout_init(&pfsyncif->sc_bulkfail_tmo, CALLOUT_MPSAFE);
 #else
 	timeout_set(&pfsyncif->sc_tmo, pfsync_timeout, pfsyncif);
 	timeout_set(&pfsyncif->sc_tdb_tmo, pfsync_tdb_timeout, pfsyncif);
Index: net/bpf.c
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/net/bpf.c,v
retrieving revision 1.178
diff -u -r1.178 bpf.c
--- net/bpf.c	17 Jun 2007 21:51:43 -0000	1.178
+++ net/bpf.c	27 Jul 2007 13:34:32 -0000
@@ -405,7 +405,7 @@
 	mac_create_bpfdesc(td->td_ucred, d);
 #endif
 	mtx_init(&d->bd_mtx, devtoname(dev), "bpf cdev lock", MTX_DEF);
-	callout_init(&d->bd_callout, NET_CALLOUT_MPSAFE);
+	callout_init(&d->bd_callout, CALLOUT_MPSAFE);
 	knlist_init(&d->bd_sel.si_note, &d->bd_mtx, NULL, NULL, NULL);
 
 	return (0);
Index: netgraph/netgraph.h
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/netgraph/netgraph.h,v
retrieving revision 1.67
diff -u -r1.67 netgraph.h
--- netgraph/netgraph.h	17 Oct 2006 10:59:39 -0000	1.67
+++ netgraph/netgraph.h	27 Jul 2007 13:34:41 -0000
@@ -1097,7 +1097,7 @@
 int	ng_uncallout(struct callout *c, node_p node);
 int	ng_callout(struct callout *c, node_p node, hook_p hook, int ticks,
 	    ng_item_fn *fn, void * arg1, int arg2);
-#define	ng_callout_init(c)	callout_init(c, NET_CALLOUT_MPSAFE)
+#define	ng_callout_init(c)	callout_init(c, CALLOUT_MPSAFE)
 
 /* Flags for netgraph functions. */
 #define	NG_NOFLAGS	0x00000000	/* no special options */
Index: netinet/ip_carp.c
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/netinet/ip_carp.c,v
retrieving revision 1.50
diff -u -r1.50 ip_carp.c
--- netinet/ip_carp.c	12 Jun 2007 16:24:53 -0000	1.50
+++ netinet/ip_carp.c	27 Jul 2007 13:34:50 -0000
@@ -384,9 +384,9 @@
 	sc->sc_imo.imo_max_memberships = IP_MIN_MEMBERSHIPS;
 	sc->sc_imo.imo_multicast_vif = -1;
 
-	callout_init(&sc->sc_ad_tmo, NET_CALLOUT_MPSAFE);
-	callout_init(&sc->sc_md_tmo, NET_CALLOUT_MPSAFE);
-	callout_init(&sc->sc_md6_tmo, NET_CALLOUT_MPSAFE);
+	callout_init(&sc->sc_ad_tmo, CALLOUT_MPSAFE);
+	callout_init(&sc->sc_md_tmo, CALLOUT_MPSAFE);
+	callout_init(&sc->sc_md6_tmo, CALLOUT_MPSAFE);
 	
 	ifp->if_softc = sc;
 	if_initname(ifp, CARP_IFNAME, unit);
Index: netinet/ip_dummynet.c
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/netinet/ip_dummynet.c,v
retrieving revision 1.107
diff -u -r1.107 ip_dummynet.c
--- netinet/ip_dummynet.c	17 Jun 2007 00:33:34 -0000	1.107
+++ netinet/ip_dummynet.c	27 Jul 2007 13:34:59 -0000
@@ -2141,7 +2141,7 @@
 	    taskqueue_thread_enqueue, &dn_tq);
 	taskqueue_start_threads(&dn_tq, 1, PI_NET, "dummynet");
 
-	callout_init(&dn_timeout, NET_CALLOUT_MPSAFE);
+	callout_init(&dn_timeout, CALLOUT_MPSAFE);
 	callout_reset(&dn_timeout, 1, dummynet, NULL);
 
 	/* Initialize curr_time adjustment mechanics. */
Index: netinet/ip_fw2.c
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/netinet/ip_fw2.c,v
retrieving revision 1.169
diff -u -r1.169 ip_fw2.c
--- netinet/ip_fw2.c	3 Jul 2007 12:46:06 -0000	1.169
+++ netinet/ip_fw2.c	27 Jul 2007 13:35:12 -0000
@@ -4937,7 +4937,7 @@
 	    sizeof(ipfw_dyn_rule), NULL, NULL, NULL, NULL,
 	    UMA_ALIGN_PTR, 0);
 	IPFW_DYN_LOCK_INIT();
-	callout_init(&ipfw_timeout, NET_CALLOUT_MPSAFE);
+	callout_init(&ipfw_timeout, CALLOUT_MPSAFE);
 
 	bzero(&default_rule, sizeof default_rule);
 
Index: netinet/ip_mroute.c
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/netinet/ip_mroute.c,v
retrieving revision 1.135
diff -u -r1.135 ip_mroute.c
--- netinet/ip_mroute.c	10 May 2007 15:58:47 -0000	1.135
+++ netinet/ip_mroute.c	27 Jul 2007 13:35:20 -0000
@@ -639,12 +639,12 @@
     pim_assert = 0;
     mrt_api_config = 0;
 
-    callout_init(&expire_upcalls_ch, NET_CALLOUT_MPSAFE);
+    callout_init(&expire_upcalls_ch, CALLOUT_MPSAFE);
 
     bw_upcalls_n = 0;
     bzero((caddr_t)bw_meter_timers, sizeof(bw_meter_timers));
-    callout_init(&bw_upcalls_ch, NET_CALLOUT_MPSAFE);
-    callout_init(&bw_meter_ch, NET_CALLOUT_MPSAFE);
+    callout_init(&bw_upcalls_ch, CALLOUT_MPSAFE);
+    callout_init(&bw_meter_ch, CALLOUT_MPSAFE);
 }
 
 static void
Index: netinet/tcp_subr.c
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/netinet/tcp_subr.c,v
retrieving revision 1.292
diff -u -r1.292 tcp_subr.c
--- netinet/tcp_subr.c	27 Jul 2007 00:57:06 -0000	1.292
+++ netinet/tcp_subr.c	27 Jul 2007 16:48:47 -0000
@@ -592,12 +592,8 @@
 		tcp_mssdflt;
 
 	/* Set up our timeouts. */
-	if (NET_CALLOUT_MPSAFE)
-		callout_init_mtx(&tp->t_timers->tt_timer, &inp->inp_mtx,
-		    CALLOUT_RETURNUNLOCKED);
-	else
-		callout_init_mtx(&tp->t_timers->tt_timer, &inp->inp_mtx,
-		    (CALLOUT_RETURNUNLOCKED|CALLOUT_NETGIANT));
+	callout_init_mtx(&tp->t_timers->tt_timer, &inp->inp_mtx,
+	    CALLOUT_RETURNUNLOCKED);
 
 	if (tcp_do_rfc1323)
 		tp->t_flags = (TF_REQ_SCALE|TF_REQ_TSTMP);
Index: sys/mutex.h
===================================================================
RCS file: /zoo/cvsup/FreeBSD-CVS/src/sys/sys/mutex.h,v
retrieving revision 1.99
diff -u -r1.99 mutex.h
--- sys/mutex.h	27 Jul 2007 11:59:57 -0000	1.99
+++ sys/mutex.h	27 Jul 2007 13:36:30 -0000
@@ -408,7 +408,6 @@
 } while (0)
 #define	NET_ASSERT_GIANT() do {						\
 } while (0)
-#define	NET_CALLOUT_MPSAFE	CALLOUT_MPSAFE
 
 struct mtx_args {
 	struct mtx	*ma_mtx;